#ifndef SD_CARD_H_
#define SD_CARD_H_

class SD_Card
{
    public:
    ~SD_Card( )
    {
        m_command_buffer[ 0 ] = 0x40;
        m_command_buffer[ 1 ] = 0x00;
        m_command_buffer[ 2 ] = 0x00;
        m_command_buffer[ 3 ] = 0x00;
        m_command_buffer[ 4 ] = 0x00;
        m_command_buffer[ 5 ] = 0x95;
    
        m_address_read_buffer = -1;
    }
    static SD_Card& create( ){ static SD_Card card; return card; }
    bool read_data( unsigned char& buf );
    bool write_data( const unsigned char& source );
    void clock_high( );
    void clock_low( );
    void chip_select_high(  );
    void chip_select_low( );
    void data_in_high( );
    void data_in_low( );
    unsigned char read_data( );
    
    private:
    SD_Card( ){ }
    typedef enum
    {
        N_STATE
    }   STATE;
    
    static const int COMMAND_LENGTH =  6;
    static const int SIZE_READ_BUFFER = 4096;
    
    void write_data_into_sd_card( const unsigned char& in );
    void write_command_into_sd_card( const unsigned char& command );
    unsigned char read_data_from_sd_card( );

    unsigned char m_command_buffer[ COMMAND_LENGTH ];
    unsigned char m_read_buffer[ SIZE_READ_BUFFER ];
    int m_address_read_buffer;

};

#endif /*SD_CARD_H_*/
